/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-23 at 23:43:45 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.reseller.model;

/**
 * JSON template for a customer.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Enterprise Apps Reseller API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Customer extends com.google.api.client.json.GenericJson {

  /**
   * The alternate email of the customer.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String alternateEmail;

  /**
   * The domain name of the customer.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String customerDomain;

  /**
   * The id of the customer.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String customerId;

  /**
   * Identifies the resource as a customer.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The phone number of the customer.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String phoneNumber;

  /**
   * The postal address of the customer.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Address postalAddress;

  /**
   * Ui url for customer resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String resourceUiUrl;

  /**
   * The alternate email of the customer.
   * @return value or {@code null} for none
   */
  public java.lang.String getAlternateEmail() {
    return alternateEmail;
  }

  /**
   * The alternate email of the customer.
   * @param alternateEmail alternateEmail or {@code null} for none
   */
  public Customer setAlternateEmail(java.lang.String alternateEmail) {
    this.alternateEmail = alternateEmail;
    return this;
  }

  /**
   * The domain name of the customer.
   * @return value or {@code null} for none
   */
  public java.lang.String getCustomerDomain() {
    return customerDomain;
  }

  /**
   * The domain name of the customer.
   * @param customerDomain customerDomain or {@code null} for none
   */
  public Customer setCustomerDomain(java.lang.String customerDomain) {
    this.customerDomain = customerDomain;
    return this;
  }

  /**
   * The id of the customer.
   * @return value or {@code null} for none
   */
  public java.lang.String getCustomerId() {
    return customerId;
  }

  /**
   * The id of the customer.
   * @param customerId customerId or {@code null} for none
   */
  public Customer setCustomerId(java.lang.String customerId) {
    this.customerId = customerId;
    return this;
  }

  /**
   * Identifies the resource as a customer.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies the resource as a customer.
   * @param kind kind or {@code null} for none
   */
  public Customer setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The phone number of the customer.
   * @return value or {@code null} for none
   */
  public java.lang.String getPhoneNumber() {
    return phoneNumber;
  }

  /**
   * The phone number of the customer.
   * @param phoneNumber phoneNumber or {@code null} for none
   */
  public Customer setPhoneNumber(java.lang.String phoneNumber) {
    this.phoneNumber = phoneNumber;
    return this;
  }

  /**
   * The postal address of the customer.
   * @return value or {@code null} for none
   */
  public Address getPostalAddress() {
    return postalAddress;
  }

  /**
   * The postal address of the customer.
   * @param postalAddress postalAddress or {@code null} for none
   */
  public Customer setPostalAddress(Address postalAddress) {
    this.postalAddress = postalAddress;
    return this;
  }

  /**
   * Ui url for customer resource.
   * @return value or {@code null} for none
   */
  public java.lang.String getResourceUiUrl() {
    return resourceUiUrl;
  }

  /**
   * Ui url for customer resource.
   * @param resourceUiUrl resourceUiUrl or {@code null} for none
   */
  public Customer setResourceUiUrl(java.lang.String resourceUiUrl) {
    this.resourceUiUrl = resourceUiUrl;
    return this;
  }

  @Override
  public Customer set(String fieldName, Object value) {
    return (Customer) super.set(fieldName, value);
  }

  @Override
  public Customer clone() {
    return (Customer) super.clone();
  }

}
